 /*
		misc DSP functions
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _DSP_H_
#define _DSP_H_

/* downsample array by factor 
input signal 
length of input signal
downsampling factor 
output signal 
length of output is floor (l / f)
even simple this is much faster than basic (especially for long lists)
doing this on the stack directly isnt much faster (because lst has to reversed)
http://www.eetimes.com/document.asp?doc_id=1275556&page_number=1 */
void Downsamp(double x[],
	unsigned short l,
	unsigned short f,
	double y[]);

/* samples per period */
double SampPerPeriod(double fs, 
	double f);
	
/* generate discrete superposition of sine waves 
sampling frequency 
number of samples 
[freq, amp, angle;...] (one row per frequency) 
??? will be faster when calculating only one period for lowest freq 
and duplicating the samples for following periods (n may not be integer 
multiple ob base frq period length */
void supossin(void);

/* downsample array by factor 
input signal 
length of input signal
downsampling factor 
output signal 
length of output is floor (l / f)
even simple this is much faster than basic (especially for long lists)
doing this on the stack directly isnt much faster (because lst has to reversed)
http://www.eetimes.com/document.asp?doc_id=1275556&page_number=1 */
void Upsamp(double x[],
	unsigned short l,
	unsigned short f,
	double y[]);

#endif
