/*
		Matrix functions
		
    Algorithm Copyright (C) 2015  Lanczos approximation from Wikipedia
    Port from python to C Copyright (C) 2015  Ralph Schenn
	
    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <tiams.h>
#include "Complex.h"
#include "Debug.h"
#include "Matrix.h"
#include "Memory.h"
#include "Real.h"

/* initialize array of doubles */
void ArrInit(double a[], 
	short l)
{
	while (--l >= 0) {
		a[l] = 0.;
	}
}

/* initialize array of doubles */
void CArrInit(Complex a[], 
	short l)
{
	while (--l >= 0) {
		a[l].real = 0.;
		a[l].imag = 0.;
	}
}

/* partially initialize complex array */
/*void CInitMat(Complex a[],
	unsigned short start, 
	unsigned short end)
{
	while (start++ < end) {
		a[start].real = 0.;
		a[start].imag = 0.;		
	}
}*/

/* element-wise multiplication of complex arrays */
/*void CMatMatMul(Complex a[], 
	Complex b[], 
	short len)
{
    while (--len >= 0) {
    	a[len] = CMul (a[len], b[len]);
    }
}*/

/* divide complex array by complex scalar */
/*void CMatScalDiv(Complex a[],
	Complex b,
	short len)
{
    while (--len >= 0) {
    	a[len] = CDiv (a[len], b);
    }
}*/

/* pads array of complex from length l1 to length l2 */
unsigned short CPadPow2(HANDLE x,
	unsigned short oldLen,
	unsigned short newLen)
{
    unsigned short i, newLenPad;
    Complex *xPtr;
    double debug;

	// next smalles power of two
	newLenPad = CeilPow2 (Max (newLen, oldLen));
	
	// old size is not power of two
	if (newLenPad > oldLen) {
		HeapReallocThrow (x, newLenPad * sizeof (Complex));
	    xPtr = HeapDeref (x);
		    
	    // loop over padded array elements
	    for (i = oldLen; i < newLenPad; i++) {
	        // initialize padded elements
	        xPtr[i].real = 0.;
	        xPtr[i].imag = 0.;
	    }          
    }
    
    return newLenPad;
}

/* matrix product
matrix A
number of rows matrix A
number of colums matrix A
matrix B
number of colums matrix B
product of matices A B 
A is an n  m matrix, B is an m  p matrix, AB is n  p matrix 
speed comparison with builtin function depends on size of matrix and data type
even without being generally faster this function is usefull because it accepts 
the matrices stored as arrays instead of storage on estack 
https://en.wikipedia.org/wiki/Matrix_multiplication#Matrix_product_.28two_matrices.29 */
/*void MatProd(double *matA, 
	const unsigned short rowsA, 
	const unsigned short colsA, 
	double *matB, 
	const unsigned short colsB,
	double *prod)
{
	unsigned short i, j, k;
	double s;
	
	// loop over rows of matrix product
	for (i = 0; i < rowsA; i++) {      
		// loop over columns of matrix product
		for (j = 0; j < colsB; j++) {  
			// reinit sum for each cell of product matrix
			s = 0;
			
			for (k = 0; k < colsA; k++) {
				 // calculate sum of products
				 s += matA[IDX2D(colsA, i, k)] * matB[IDX2D(colsB, k, j)];
			}
			
			// store sum into product matrix
			prod[IDX2D(colsB, i, j)] = s;
		}
	}
}*/

   

