/*
		Moving Average
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <tiams.h>
#include "MovAvg.h"
#include "Stack.h"

/* Moving Average
input signal
input signal length
average length */
void MovAvg(double x[], 
	unsigned short xl, 
	unsigned short l,
	double y[])
{ 	
	unsigned short right = xl - l;
	unsigned short i;
	double s = 0;
 
	// initial sum calculation
	for (i = 0; i < l; i++) {
		s += x[i];
	}
 
	y[0] = s / l;  
 
	// moving average
	for (i = 0; i < right; i++) {
		// add next input sample
		// subtract previous input sample
		s += x[i + l] - x[i];
		
		y[i + 1] = s / l;
	}
}
