/*
		ROM calls missing in tiams.h
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

/* the following functions are declared only to be able to pass their 
addresses as function pointers to wrapper functions in BE.c 
passing the addresses directly without the wrappers doesnt compile */
 
#include <tiams.h>
#include "ROM.h"

void cmdpause(EStackIndex i)
{
	cmd_pause (i);
}

void cmdrandseed(EStackIndex i)
{
	cmd_randseed (i);
}

void cmdsorta(EStackIndex i)
{
	cmd_sorta (i);
}

void cmdsortd(EStackIndex i)
{
	cmd_sortd (i);
}

void fdeletew(char name[])
{
	FDelete (name);
}

Boolean isantisymmetricw(EStackIndex expr_ptr, EStackIndex var_ptr)
{
	return is_antisymmetric (expr_ptr, var_ptr);
}

Boolean isconstantw(EStackIndex i)
{
	return is_constant (i);
}

Boolean isindependentofw(EStackIndex i, EStackIndex j)
{
	return is_independent_of (i, j);
}

Boolean isnegativew(EStackIndex i)
{
	return is_negative (i);
}

Boolean isnever0w(EStackIndex i)
{
	return is_never0 (i);
}

Boolean ispositivew(EStackIndex i)
{
	return is_positive (i);
}

Boolean isrealw(EStackIndex i)
{
	return is_real (i);
}

Boolean issymmetricw(EStackIndex expr_ptr, EStackIndex var_ptr)
{
	return is_symmetric (expr_ptr, var_ptr);
}

Boolean isvariablew(EStackIndex i)
{
	return is_variable (i);
}

void pushpolydeginvarorkernelw(EStackIndex i, EStackIndex vi)
{
	push_poly_deg_in_var_or_kernel (i, vi);
}

void sthelpmsgw(char str[])
{
	ST_helpMsg (str);
}
