 /*
		real functions
		
    Copyright (C) 2015  Ralph Schenn

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <tiams.h>

#ifndef _REAL_H_
#define _REAL_H_       

#define RAND_MAX 32767

/* round to next smallest power of two */
unsigned int CeilPow2(unsigned int x);

/* check if number is power of 2 */
Boolean IsPow2(unsigned int x);

/* binary logarithm */
double Log2(double x);

/* max of two numbers */
int Max(int a, int b);

/* random number between 1 and RAND_MAX */
unsigned short Rand(void);

#endif

